"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

exports.mapWidths = mapWidths;
exports.mapOrientations = mapOrientations;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mapWidths(browser) {
  var widths = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
  var iteratee = arguments[2];

  var results, _ref, width, result, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _width, _result;

  return _regenerator2.default.async(function mapWidths$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          results = [];

          if (widths.length) {
            _context.next = 12;
            break;
          }

          _context.next = 4;
          return _regenerator2.default.awrap(browser.windowHandleSize());

        case 4:
          _ref = _context.sent;
          width = _ref.width;
          _context.next = 8;
          return _regenerator2.default.awrap(iteratee(width));

        case 8:
          result = _context.sent;

          results.push(result);
          _context.next = 42;
          break;

        case 12:
          _iteratorNormalCompletion = true;
          _didIteratorError = false;
          _iteratorError = undefined;
          _context.prev = 15;
          _iterator = (0, _getIterator3.default)(widths);

        case 17:
          if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
            _context.next = 28;
            break;
          }

          _width = _step.value;
          _context.next = 21;
          return _regenerator2.default.awrap(browser.windowHandleSize({ width: _width, height: 1000 }));

        case 21:
          _context.next = 23;
          return _regenerator2.default.awrap(iteratee(_width));

        case 23:
          _result = _context.sent;

          results.push(_result);

        case 25:
          _iteratorNormalCompletion = true;
          _context.next = 17;
          break;

        case 28:
          _context.next = 34;
          break;

        case 30:
          _context.prev = 30;
          _context.t0 = _context["catch"](15);
          _didIteratorError = true;
          _iteratorError = _context.t0;

        case 34:
          _context.prev = 34;
          _context.prev = 35;

          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }

        case 37:
          _context.prev = 37;

          if (!_didIteratorError) {
            _context.next = 40;
            break;
          }

          throw _iteratorError;

        case 40:
          return _context.finish(37);

        case 41:
          return _context.finish(34);

        case 42:
          return _context.abrupt("return", results);

        case 43:
        case "end":
          return _context.stop();
      }
    }
  }, null, this, [[15, 30, 34, 42], [35,, 37, 41]]);
}

function mapOrientations(browser) {
  var orientations = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
  var iteratee = arguments[2];

  var results, orientation, result, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, _orientation, _result2;

  return _regenerator2.default.async(function mapOrientations$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          results = [];

          if (orientations.length) {
            _context2.next = 11;
            break;
          }

          _context2.next = 4;
          return _regenerator2.default.awrap(browser.getOrientation());

        case 4:
          orientation = _context2.sent;
          _context2.next = 7;
          return _regenerator2.default.awrap(iteratee(orientation));

        case 7:
          result = _context2.sent;

          results.push(result);
          _context2.next = 41;
          break;

        case 11:
          _iteratorNormalCompletion2 = true;
          _didIteratorError2 = false;
          _iteratorError2 = undefined;
          _context2.prev = 14;
          _iterator2 = (0, _getIterator3.default)(orientations);

        case 16:
          if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
            _context2.next = 27;
            break;
          }

          _orientation = _step2.value;
          _context2.next = 20;
          return _regenerator2.default.awrap(browser.setOrientation(_orientation));

        case 20:
          _context2.next = 22;
          return _regenerator2.default.awrap(iteratee(_orientation));

        case 22:
          _result2 = _context2.sent;

          results.push(_result2);

        case 24:
          _iteratorNormalCompletion2 = true;
          _context2.next = 16;
          break;

        case 27:
          _context2.next = 33;
          break;

        case 29:
          _context2.prev = 29;
          _context2.t0 = _context2["catch"](14);
          _didIteratorError2 = true;
          _iteratorError2 = _context2.t0;

        case 33:
          _context2.prev = 33;
          _context2.prev = 34;

          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }

        case 36:
          _context2.prev = 36;

          if (!_didIteratorError2) {
            _context2.next = 39;
            break;
          }

          throw _iteratorError2;

        case 39:
          return _context2.finish(36);

        case 40:
          return _context2.finish(33);

        case 41:
          return _context2.abrupt("return", results);

        case 42:
        case "end":
          return _context2.stop();
      }
    }
  }, null, this, [[14, 29, 33, 41], [34,, 36, 40]]);
}